//Grade book program used to demonstrate 2D arrays and searching of arrays 
#include <iostream>
#include <iomanip>
#include <fstream>
using namespace std;

// Global Constant
const int CLASS_SIZE = 100;
const int MAX_SCORES = 50;
const int NAME_SIZE = 50;

// Prototypes
void displayMenu();
void makeRoomForNewStudent(char studentName[], char students[][NAME_SIZE], double scores[][MAX_SCORES], 
				int startingRow, int endingRow, int scoreCount);
void scoreRowCpy(double scores[][MAX_SCORES], int destinationRowNumber, int sourceRowNumber, int scoreCount);
void newStudent(char students[][NAME_SIZE], char columnTitles[][NAME_SIZE], double scores[][MAX_SCORES], 
				int & studentCount, int scoreCount);

void makeRoomForNewColumnTitle(char columnTitles[][NAME_SIZE], double scores[][MAX_SCORES], 
				int startingColumn, int endingColumn, int studentCount);
void scoreColumnCpy(double scores[][MAX_SCORES], int destinationColumnNumber, 
					int sourceColumnNumber, int studentCount);
void addColumnOfScores(char students[][NAME_SIZE], char columnTitles[][NAME_SIZE], double scores[][MAX_SCORES], 
				int studentCount, int & scoreCount);

void changeAScore(char students[][NAME_SIZE], char columnTitles[][NAME_SIZE], double scores[][MAX_SCORES], 
				int & studentCount, int scoreCount);

void listSearch(char target[], char stringList[][NAME_SIZE], int stringCount, bool & found, int & locationFound);
void getScoresInteractively(double scores[], int & count);
void printScores(char students[][NAME_SIZE], char columnTitles[][NAME_SIZE], double scores[][MAX_SCORES], int studentCount, int scoresCount);
double averageScores(double scores[], int count);
void saveScoresToFile(char fileName[], char students[][NAME_SIZE], char columnTitles[][NAME_SIZE], double scores[][MAX_SCORES], int & studentCount, int & scoreCount);
double averageColumn(double scores[][MAX_SCORES], int columnNumber, int studentCount, int scoreCount);
void possiblySaveScoresToFile(char fileName[], char students[][NAME_SIZE], char columnTitles[][NAME_SIZE], double scores[][MAX_SCORES], int & studentCount, int & scoreCount);
void readScoresFromFile(char fileName[], char students[][NAME_SIZE], char columnTitles[][NAME_SIZE], double scores[][MAX_SCORES], int & studentCount, int & scoreCount);
void gradeBookMenu(char students[][NAME_SIZE], char columnTitles[][NAME_SIZE], double scores[][MAX_SCORES], int & studentCount, int & scoreCount);

int main() {
	double scores[CLASS_SIZE][MAX_SCORES];
	char fileName[NAME_SIZE], 
		 studentNames[CLASS_SIZE][NAME_SIZE];
	char columnTitles[MAX_SCORES][NAME_SIZE];
	int numberOfScores, numberOfStudents;
	
	readScoresFromFile(fileName, studentNames, columnTitles, scores, numberOfStudents, numberOfScores);
	printScores(studentNames, columnTitles, scores, numberOfStudents, numberOfScores);

	gradeBookMenu(studentNames, columnTitles, scores, numberOfStudents, numberOfScores);

	possiblySaveScoresToFile(fileName, studentNames, columnTitles, scores, numberOfStudents, numberOfScores);
	
} // end main


// Display the Grade Book Menu
void displayMenu() {
	cout << endl << "Grade Book Menu" << endl << endl;

	cout << "(D)isplay all scores" << endl;
	cout << "(A)dd column of scores " << endl;
	cout << "(N)ew student" << endl;
	cout << "(C)hange a score" << endl;
	cout << "(Q)uit program" << endl;
	
} // end displayMenu


// Repeatedly process Grade Book requests until user decides to Quit.
void gradeBookMenu(char students[][NAME_SIZE], char columnTitles[][NAME_SIZE], double scores[][MAX_SCORES], int & studentCount, int & scoreCount) {
	char response[NAME_SIZE];

	while (true) {
		displayMenu();
		cout << endl << "Enter your choice: ";
		cin.getline(response, NAME_SIZE);
		if (strcmp(response, "D") == 0 || strcmp(response, "d") == 0) {

			cout << endl << "Display of all scores:" << endl << endl;
			printScores(students, columnTitles, scores, studentCount, scoreCount);
		
		} else if (strcmp(response, "A") == 0 || strcmp(response, "a") == 0) {

			addColumnOfScores(students, columnTitles, scores, studentCount, scoreCount);

		} else if (strcmp(response, "N") == 0 || strcmp(response, "n") == 0) {

			newStudent(students, columnTitles, scores, studentCount, scoreCount);

		} else if (strcmp(response, "C") == 0 || strcmp(response, "c") == 0) {

			changeAScore(students, columnTitles, scores, studentCount, scoreCount);

		} else if (strcmp(response, "Q") == 0 || strcmp(response, "q") == 0) {
			break;
		} else {
			cout << "Invalid response!  Please select from the following." << endl << endl;
		} // end if
	} // end while

} // end gradeBookMenu


// Search the sorted stringList for the target.  If the target is in the stringList, the function returns with found equal to 
// true and locationFound specifying the index where target was found in stringList.  If the target is not in the list, then
// the function returns with found equal false and locationFound specifying where the target should be added to the stringList.
void listSearch(char target[], char stringList[][NAME_SIZE], int stringCount, bool & found, int & locationFound) {
	int testIndex;

	// ADD CODE HERE FOR PART A

} // end listSearch


// Slides the students and scores "down" one row from the startingRow to 
// the endingRow.  This makes room to add a new student name and scores in the startingRow.
void makeRoomForNewStudent(char students[][NAME_SIZE], double scores[][MAX_SCORES], 
				int startingRow, int endingRow, int scoreCount) {
	int row;

	for (row = endingRow; row >= startingRow; row--) {
		strcpy_s(students[row+1], NAME_SIZE, students[row]);
		scoreRowCpy(scores, row+1, row, scoreCount);
	} // end for
} // end makeRoomForNewStudent


// Copies the sourceRowNumber row of scores to the destinationRowNumber row of scores
void scoreRowCpy(double scores[][MAX_SCORES], int destinationRowNumber, int sourceRowNumber, int scoreCount) {
	int column;

	// ADD CODE HERE FOR PART B

} // end scoreRowCpy


// Slides the columnTitles and scores to the "right" one column from the startingColumn to 
// the endingColumn.  This makes room to add a new column title and scores in the startingColumn.
void makeRoomForNewColumnTitle(char columnTitles[][NAME_SIZE], double scores[][MAX_SCORES], 
				int startingColumn, int endingColumn, int studentCount) {
	int column;

	// EXTRA CREDIT 

} // end makeRoomForNewColumnTitle


// Copies the sourceColumnNumber column of scores to the destinationColumnNumber column of scores
void scoreColumnCpy(double scores[][MAX_SCORES], int destinationColumnNumber, 
					int sourceColumnNumber, int studentCount) {
	int row;

	// EXTRA CREDIT

} // end scoreRowCpy


// Allows the user to enter the student name and column title of the score to be changed.  If both are 
// valid, then the user enters a new score.
void changeAScore(char students[][NAME_SIZE], char columnTitles[][NAME_SIZE], double scores[][MAX_SCORES], 
				int & studentCount, int scoreCount) {
	char studentName[NAME_SIZE], columnTitle[NAME_SIZE];
	bool found;
	int row, column;

	cout << "Enter the name of the student: ";
	cin.getline(studentName, NAME_SIZE);
	listSearch(studentName, students, studentCount, found, row);
	if (found) {
		cout << studentName << " found at location " << row << endl;
		cout << "Enter the column title: ";
		cin.getline(columnTitle, NAME_SIZE);
		listSearch(columnTitle, columnTitles, scoreCount, found, column);
		if (found) {
			cout << columnTitle << " found at location " << column << endl;
			cout << "The OLD score to be changed is " << scores[row][column] << endl;
			cout << "What would you like to change it to? ";
			cin >> scores[row][column];
			cin.ignore(NAME_SIZE, '\n');
		} else {
			cout << columnTitle << " NOT found, but should have been at column " << column << endl;
		} // end if
	} else {
		cout << studentName << " NOT found, but should have been at row " << row << endl;
	} // end if

} // end changeAScore


// Allows the user to enter a new student and their scores for each column.
void newStudent(char students[][NAME_SIZE], char columnTitles[][NAME_SIZE], double scores[][MAX_SCORES], 
				int & studentCount, int scoreCount) {
	char studentName[NAME_SIZE];
	bool found;
	int row, column;

	cout << "Enter the name of the new student: ";
	cin.getline(studentName, NAME_SIZE);
	listSearch(studentName, students, studentCount, found, row);
	if (found) {
		cout << studentName << " found, at row " << row << endl;
	} else {
		cout << studentName << " NOT found would have been at row " << row << endl;
		makeRoomForNewStudent(students, scores, row, studentCount-1, scoreCount);
		strcpy_s(students[row], NAME_SIZE, studentName);
		for (column = 0; column < scoreCount; column++) {
			cout << "For " << studentName << " enter a score for " << columnTitles[column] << ": ";
			cin >> scores[row][column];
		} // end for
		cin.ignore(NAME_SIZE, '\n');
		studentCount++;
	} // end if

} // end newStudent


// Allows the user to add a new column title and corresponding scores for each student.
void addColumnOfScores(char students[][NAME_SIZE], char columnTitles[][NAME_SIZE], double scores[][MAX_SCORES], 
				int studentCount, int & scoreCount) {
	char columnTitle[NAME_SIZE];
	bool found;
	int row, column;

	cout << "Enter the new column title: ";
	cin.getline(columnTitle, NAME_SIZE);
	listSearch(columnTitle, columnTitles, scoreCount, found, column);
	if (found) {
		cout << columnTitle << " found, at column " << column << endl;
	} else {
		cout << columnTitle << " NOT found would have been at column " << column << endl;
		makeRoomForNewColumnTitle(columnTitles, scores, column, scoreCount-1, studentCount);
		strcpy_s(columnTitles[column], NAME_SIZE, columnTitle);
		for (row = 0; row < studentCount; row++) {
			cout << "For " << students[row] << " enter a score for " << columnTitle << ": ";
			cin >> scores[row][column];
		} // end for
		cin.ignore(NAME_SIZE, '\n');
		scoreCount++;
	} // end if

} // end addColumnOfScores


// Prints the grade book to console 
void printScores(char students[][NAME_SIZE], char columnTitles[][NAME_SIZE], double scores[][MAX_SCORES], int studentCount, int scoreCount) {
	int row, column;

	cout << "There are " << studentCount << " students with " << scoreCount << " scores." << endl << endl;

	// Print Column Titles
	cout << left << setw(17) << "Student Names";
	for (column = 0; column < scoreCount; column++) {
		cout << right << setw(6) << columnTitles[column] << " ";		
	} // end for (column...
	cout << endl;

	// Print student names and scores
	for (row = 0; row < studentCount; row++) {
		cout << left << setw(15) << students[row];
		cout << ": ";
		for (column = 0; column < scoreCount; column++) {
			cout << right << setw(6) << scores[row][column] << " ";		
		} // end for (column...
		cout << "Average Score = " << fixed << setprecision(1) << averageScores(scores[row],scoreCount) << endl;
	} // end for (row...

	// print column averages
	cout << left << setw(17) << "Column Averages";
	for (column = 0; column < scoreCount; column++) {
		cout << right << setw(6) << averageColumn(scores, column, studentCount, scoreCount) << " ";		
	} // end for (column...
	cout << endl << endl;

} // end printScores


// Returns the average of a column in the 2D scores array
double averageColumn(double scores[][MAX_SCORES], int columnNumber, int studentCount, int scoreCount) {
	double total;
	int row;

	if (studentCount <= 0) {
		cout << "Error: To calculate the average, you must have one or more scores!" << endl;
		exit(EXIT_FAILURE);
	} // end if

	total = 0;
	for(row = 0; row < studentCount; row++) {
		total += scores[row][columnNumber];
	} // end for
	return total / studentCount;

} // end averageColumn


// Returns the average of a row in the 2D scores array
double averageScores(double scores[], int count) {
	double total;
	int index;

	total = 0;
	for(index = 0; index < count; index++) {
		total += scores[index];
	} // end for

	if (count <= 0) {
		cout << "Error: To calculate the average, you must have one or more scores!" << endl;
		exit(EXIT_FAILURE);
	} else {
		return total / count;
	} // end if

} // end averageScores


// Saves the complete grade book to a text file
void saveScoresToFile(char fileName[], char students[][NAME_SIZE], char columnTitles[][NAME_SIZE],
					  double scores[][MAX_SCORES], int & studentCount, int & scoreCount) {
	int row, column;
	ofstream outFile;

	outFile.open(fileName);
	outFile << studentCount << " " << scoreCount << endl;

	for (row = 0; row < studentCount; row++) {
		outFile << students[row] << endl;
		for (column = 0; column < scoreCount; column++) {
			outFile << scores[row][column] << " ";
		} // end for (column...
		outFile << endl;
	} // end for (row...

	for (column = 0; column < scoreCount; column++) {
		outFile << columnTitles[column] << endl;
	} // end for (column...

	outFile.close();
} // end saveScoresToFile


// Reads a grade book file into the arrays
void readScoresFromFile(char fileName[], char students[][NAME_SIZE], char columnTitles[][NAME_SIZE], 
						double scores[][MAX_SCORES], int & studentCount, int & scoreCount) {
	int row, column;
	double score;
	ifstream inFile;

	cout << "Enter the file containing student scores: ";
	cin.getline(fileName, NAME_SIZE);
	inFile.open(fileName);
	if (!inFile) {
		cout << "Error opening file <" << fileName << "> for reading!";
	} else {
		inFile >> studentCount;
		inFile >> scoreCount;

		inFile.ignore(NAME_SIZE, '\n');
		for (row = 0; row < studentCount; row++) {
			inFile.getline(students[row],NAME_SIZE);

			for (column = 0; column < scoreCount; column++) {
				inFile >> score;
				scores[row][column] = score;
			} // end for (column...

			inFile.ignore(NAME_SIZE, '\n');
		} // end for (row...

		for (column = 0; column < scoreCount; column++) {
			inFile.getline(columnTitles[column], NAME_SIZE);
		} // end for (column...

		inFile.close();
	} // end if
} // end readScoresFromFile


// Determines if the user wants to save the grade book information to a file
void possiblySaveScoresToFile(char fileName[], char students[][NAME_SIZE], char columnTitles[][NAME_SIZE], 
							  double scores[][MAX_SCORES], int & studentCount, int & scoreCount) {
	char response[NAME_SIZE];

	while (true) {
		cout << "Would you like to save the scores to a file (y or n)?: ";
		cin.getline(response, NAME_SIZE);
		if (strcmp(response, "n") == 0) {
			cout << "Scores not saved" << endl;
			break;
		} else if (strcmp(response, "y") == 0) {
			cout << "Enter the file name where you want the scores saved: ";
			cin.getline(fileName, NAME_SIZE);
			saveScoresToFile(fileName, students, columnTitles, scores, 
				studentCount, scoreCount);
			break; 
		} else {
			cout << "Invalid response!  Please enter only f or i. " << endl;
		} // end if
	} // end while

} // end possiblySaveScoresToFile